Attribute VB_Name = "XpControls"
'*******************************************************************************************************
'********************************************
'*********************              XpControls functions
'**
'*
'* Author: Jottum
'* Date  : 07/20/2007 (mm/dd/yyyy)
'* Site  : http://www.uitdeschriften.com/files/VB6/
'*
'*
'* Feel free to use this code, but please give proper credits
'*
'**
'*********************
'********************************************
'*******************************************************************************************************

Option Explicit
' API calls, Types, Enums and Const declarations.

'Tab constants. (Code by vbAccelerator.com)
Private Enum ThemeTabParts
   TAB_TABITEM = 1
   TAB_TABITEMLEFTEDGE = 2
   TAB_TABITEMRIGHTEDGE = 3
   TAB_TABITEMBOTHEDGE = 4
   TAB_TOPTABITEM = 5
   TAB_TOPTABITEMLEFTEDGE = 6
   TAB_TOPTABITEMRIGHTEDGE = 7
   TAB_TOPTABITEMBOTEDGE = 8
   TAB_PANE = 9
   TAB_BODY = 10
End Enum

Private Enum ThemeTabItemStates
   TIS_NORMAL = 1
   TIS_HOT = 2
   TIS_SELECTED = 3
   TIS_DISABLED = 4
   TIS_FOCUSED = 5
End Enum

Private Enum ThemeTabItemLeftEdgeStates
   TILES_NORMAL = 1
   TILES_HOT = 2
   TILES_SELECTED = 3
   TILES_DISABLED = 4
   TILES_FOCUSED = 5
End Enum

Private Enum ThemeTabItemRightEdgeStates
   TIRES_NORMAL = 1
   TIRES_HOT = 2
   TIRES_SELECTED = 3
   TIRES_DISABLED = 4
   TIRES_FOCUSED = 5
End Enum

Private Enum ThemeTabItemBotEdgeStates
   TIBES_NORMAL = 1
   TIBES_HOT = 2
   TIBES_SELECTED = 3
   TIBES_DISABLED = 4
   TIBES_FOCUSED = 5
End Enum

Private Enum ThemeTopTabItemStates
   TTIS_NORMAL = 1
   TTIS_HOT = 2
   TTIS_SELECTED = 3
   TTIS_DISABLED = 4
   TTIS_FOCUSED = 5
End Enum

Private Enum ThemeTopTabItemLeftEdgeStates
   TTILES_NORMAL = 1
   TTILES_HOT = 2
   TTILES_SELECTED = 3
   TTILES_DISABLED = 4
   TTILES_FOCUSED = 5
End Enum

Private Enum ThemeTopTabItemRightEdgeStates
   TTIRES_NORMAL = 1
   TTIRES_HOT = 2
   TTIRES_SELECTED = 3
   TTIRES_DISABLED = 4
   TTIRES_FOCUSED = 5
End Enum

Private Enum ThemeTopTabItemBotEdgeStates
   TTIBES_NORMAL = 1
   TTIBES_HOT = 2
   TTIBES_SELECTED = 3
   TTIBES_DISABLED = 4
   TTIBES_FOCUSED = 5
End Enum

Public Enum THEMESIZE
    TS_MIN             '// minimum size
    TS_TRUE            '// size without stretching
    TS_DRAW            '// size that theme mgr will use to draw part
End Enum

'Miscellaneous
Private Const DT_LEFT = &H0
Private Const DT_TOP = &H0
Private Const DT_CENTER = &H1
Private Const DT_RIGHT = &H2
Private Const DT_VCENTER = &H4
Private Const DT_BOTTOM = &H8&
Private Const DT_SINGLELINE = &H20

Private Const TMT_FONT = 210
Private Const SW_SHOWNORMAL = 1

'\DrawEdge
Private Const BDR_RAISEDOUTER = &H1
Private Const BDR_SUNKENOUTER = &H2
Private Const BDR_RAISEDINNER = &H4
Private Const BDR_SUNKENINNER = &H8

Private Const BDR_OUTER = &H3
Private Const BDR_INNER = &HC
Private Const BDR_RAISED = &H5
Private Const BDR_SUNKEN = &HA

Private Const EDGE_RAISED = (BDR_RAISEDOUTER Or BDR_RAISEDINNER)
Private Const EDGE_SUNKEN = (BDR_SUNKENOUTER Or BDR_SUNKENINNER)
Private Const EDGE_ETCHED = (BDR_SUNKENOUTER Or BDR_RAISEDINNER)
Private Const EDGE_BUMP = (BDR_RAISEDOUTER Or BDR_SUNKENINNER)

Private Const BF_LEFT = &H1
Private Const BF_TOP = &H2
Private Const BF_RIGHT = &H4
Private Const BF_BOTTOM = &H8

Private Const BF_TOPLEFT = (BF_TOP Or BF_LEFT)
Private Const BF_TOPRIGHT = (BF_TOP Or BF_RIGHT)
Private Const BF_BOTTOMLEFT = (BF_BOTTOM Or BF_LEFT)
Private Const BF_BOTTOMRIGHT = (BF_BOTTOM Or BF_RIGHT)
Private Const BF_RECT = (BF_LEFT Or BF_TOP Or BF_RIGHT Or BF_BOTTOM)
' --/
   
   
'API Declarations.

Private Declare Function GetClientRect Lib "user32" _
   (ByVal hWnd As Long, lpRect As RECT) As Long

Private Declare Function GetWindowRect Lib "user32" _
   (ByVal hWnd As Long, lpRect As RECT) As Long

Private Declare Function InflateRect Lib "user32" _
   (lpRect As RECT, ByVal X As Long, ByVal Y As Long) As Long

Private Declare Function GetDesktopWindow Lib "user32" _
   () As Long
   
Private Declare Function DrawEdge Lib "user32" _
   (ByVal hDC As Long, qrc As RECT, ByVal edge As Long, _
    ByVal grfFlags As Long) As Long

Private Declare Function DrawText Lib "user32" _
   Alias "DrawTextA" (ByVal hDC As Long, ByVal lpStr As String, _
   ByVal nCount As Long, lpRect As RECT, ByVal wFormat As Long) As Long

Private Declare Function BitBlt Lib "gdi32" _
   (ByVal hDCDest As Long, ByVal xDest As Long, ByVal yDest As Long, _
    ByVal nWidth As Long, ByVal nHeight As Long, ByVal hdcSrc As Long, _
    ByVal xSrc As Long, ByVal ySrc As Long, ByVal dwRop As Long) As Long
    
Private Declare Function DrawFocusRect Lib "user32" _
   (ByVal hDC As Long, lpRect As RECT) As Long
   
Private Declare Function GetDC Lib "user32" _
   (ByVal hWnd As Long) As Long
   
Private Declare Function ReleaseDC Lib "user32" _
   (ByVal hWnd As Long, ByVal hDC As Long) As Long
   
Private Declare Function ShellExecute Lib "shell32.dll" Alias "ShellExecuteA" _
   (ByVal hWnd As Long, ByVal lpOperation As String, ByVal lpFile As String, _
    ByVal lpParameters As String, ByVal lpDirectory As String, _
    ByVal nShowCmd As Long) As Long

Private Declare Function GetClassLong Lib "user32.dll" Alias "GetClassLongA" _
  (ByVal hWnd As Long, ByVal nIndex As Long) As Long

Private Declare Function SetClassLong Lib "user32.dll" Alias "SetClassLongA" _
  (ByVal hWnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long

Private Declare Function SendMessageLong Lib "user32" Alias "SendMessageA" _
  (ByVal hWnd As Long, ByVal wMsg As Long, ByVal wParam As Long, _
   ByVal lParam As Long) As Long

Private Declare Function GetStockObject Lib "gdi32" (ByVal nIndex As Long) As Long

Private Declare Function HideCaret Lib "user32" (ByVal hWnd As Long) As Long
Private Declare Function ShowCaret Lib "user32" (ByVal hWnd As Long) As Long

Private Declare Function ScreenToClient Lib "user32" (ByVal hWnd As Long, lpPoint As POINTAPI) As Long

Private Declare Function OleTranslateColor Lib "oleaut32.dll" (ByVal lOleColor As Long, ByVal lHPalette As Long, lColorRef As Long) As Long

Private Const GCL_STYLE = -26
Private Const CS_DROPSHADOW = &H20000
Private Const EM_GETLINECOUNT = 186


'Theme API Declarations.
Private Declare Function GetThemeFont Lib "uxtheme.dll" ( _
   ByVal hTheme As Long, _
   ByVal hDC As Long, _
   ByVal iPartId As Long, _
   ByVal iStateId As Long, _
   ByVal iPropId As Long, _
   tLogFont As FONTSLOG) As Long

Private Declare Function OpenThemeData Lib "uxtheme.dll" _
   (ByVal hWnd As Long, ByVal pszClassList As Long) As Long
   
Private Declare Function IsThemeActive Lib "uxtheme.dll" _
   () As Boolean

Private Declare Function CloseThemeData Lib "uxtheme.dll" _
   (ByVal hTheme As Long) As Long
   
Private Declare Function DrawThemeBackground Lib "uxtheme.dll" _
   (ByVal hTheme As Long, ByVal lHdc As Long, _
    ByVal iPartId As Long, ByVal iStateId As Long, _
    pRect As RECT, pClipRect As RECT) As Long
    
Private Declare Function DrawThemeText Lib "uxtheme.dll" _
   (ByVal hTheme As Long, ByVal hDC As Long, ByVal iPartId As Long, _
    ByVal iStateId As Long, ByVal pszText As Long, _
    ByVal iCharCount As Long, ByVal dwTextFlag As Long, _
    ByVal dwTextFlags2 As Long, pRect As RECT) As Long
    
Private Declare Function GetThemeRect Lib "uxtheme.dll" ( _
   ByVal hTheme As Long, _
   ByVal iPartId As Long, _
   ByVal iStateId As Long, _
   ByVal iPropId As Long, _
   ByRef pRect As RECT) As Long
   
Private Const LF_FACESIZE = 32

' Code by vbAccelerator.com
Public Type LOGFONT
   lfHeight As Long                    ' The font Size
   lfWidth As Long                     ' Normally you don't set this, just let Windows create the Default
   lfEscapement As Long                ' The angle, in 0.1 degrees, of the font
   lfOrientation As Long               ' Leave as default
   lfWeight As Long                    ' Bold, Extra Bold, Normal etc
   lfItalic As Byte                    ' As it says
   lfUnderline As Byte                 ' As it says
   lfStrikeOut As Byte                 ' As it says
   lfCharSet As Byte                   ' As it says
   lfOutPrecision As Byte              ' Leave for default
   lfClipPrecision As Byte             ' Leave for default
   lfQuality As Byte                   ' Leave for default
   lfPitchAndFamily As Byte            ' Leave for default
   lfFaceName(LF_FACESIZE) As Byte     ' The font name converted to a byte array
End Type

' Code by vbAccelerator.com
Public Type FONTSLOG
  flfHeight As Long
  flfWidth As Long
  flfEscapement As Long
  flfOrientation As Long
  flfWeight As Long
  flfItalic As Byte
  flfUnderline As Byte
  flfStrikeOut As Byte
  flfCharSet As Byte
  flfOutPrecision As Byte
  flfClipPrecision As Byte
  flfQuality As Byte
  flfPitchAndFamily As Byte
  flfFaceName As String * LF_FACESIZE
End Type

'DrawTabStripCheat
Public Type DTSCRECT
   dtsc_Left As Long
   dtsc_Top As Long
   dtsc_Right As Long
   dtsc_Bottom As Long
End Type

Public Enum PROGRESSPARTS
   PP_BAR = 1
   PP_BARVERT = 2
   PP_CHUNK = 3
   PP_CHUNKVERT = 4
End Enum

Public Type POINTAPI
   X As Long
   Y As Long
End Type

Public Type RECT
   Left As Long
   Top As Long
   Right As Long
   Bottom As Long
End Type

' Code by Jottum
Public Enum MousePointerConstants
   Default
   Arrow
   Cross
   [i-Beam]
   Icon
   SIZE
   [Size NE SW]
   [Size N S]
   [Size NW SE]
   [Size W E]
   [Up Arrow]
   Hourglass
   [No Drop]
   [Arrow and Hourglass]
   [Arrow and Question]
   [Size All]
   Custom = 99
End Enum

' Code by Kim Pederson
Public Enum ProgressStyles
   [Vertical Solid]
   [Horizontal Chunk]
   [Horizontal Solid]
End Enum

' Code by Jottum
Public Enum DisabledSettings
   ContainerOnly              'Same as regular container (default)
   IncludeControls            'Disable container and all controls it contains
End Enum

' Code by Jottum
Public Enum VisibleSettings
   IncludeAll                 'Hide container and all controls it contains
   MeOnly                     'Same as regular container
End Enum

Public Enum DisabledStyles
   DisabledColor
   Transparency
End Enum

' Code by Jottum
Public Enum BorderStyless
   None
   Xp        '<-------------------------------------------<<< Default.
   Legacy
   TextBoxXp
   ProgressXp
   TabPage
End Enum

'WinVersion structure
Public Type WINVERINFO
   lMajor As Long
   lMinor As Long
   lRevision As Long
   lBuildNumber As Long
End Type

' Code by Jottum
Public Enum BackStyleConstants
   Transparent
   Opaque
End Enum

'pszClassList Items.  Code by Jottum
Public Type pszClassList
   PSZ_BUTTON As String
   PSZ_COMBOBOX As String
   PSZ_EDIT As String
   PSZ_EXPLORERBAR As String
   PSZ_HEADER As String
   PSZ_LISTVIEW As String
   PSZ_MENU As String
   PSZ_PAGE As String
   PSZ_PROGRESS As String
   PSZ_REBAR As String
   PSZ_SCROLLBAR As String
   PSZ_SPIN As String
   PSZ_STARTPANEL As String
   PSZ_STATUS As String
   PSZ_TAB As String
   PSZ_TASKBAND As String
   PSZ_TASKBAR As String
   PSZ_TASKBARCLOCK As String
   PSZ_TOOLBAR As String
   PSZ_TOOLTIPS As String
   PSZ_TRACKBAR As String
   PSZ_TRAYNOTIFY As String
   PSZ_TREEVIEW As String
End Type

Public Const COL_SYS_MASK = &H80000000


'Code by Jottum
Public Function ClassListItems() As pszClassList

   Dim tmpClassListItems As pszClassList
   
   With tmpClassListItems
      .PSZ_BUTTON = "Button"
      .PSZ_COMBOBOX = "ComboBox"
      .PSZ_EDIT = "Edit"
      .PSZ_EXPLORERBAR = "ExplorerBar"
      .PSZ_HEADER = "Header"
      .PSZ_LISTVIEW = "ListView"
      .PSZ_MENU = "Menu"
      .PSZ_PAGE = "Page"
      .PSZ_PROGRESS = "Progress"
      .PSZ_REBAR = "Rebar"
      .PSZ_SCROLLBAR = "Scrollbar"
      .PSZ_SPIN = "Spin"
      .PSZ_STARTPANEL = "StartPanel"
      .PSZ_STATUS = "Status"
      .PSZ_TAB = "Tab"
      .PSZ_TASKBAND = "TaskBand"
      .PSZ_TASKBAR = "TaskBar"
      .PSZ_TASKBARCLOCK = "Taskbar Clock"
      .PSZ_TOOLBAR = "Toolbar"
      .PSZ_TOOLTIPS = "Tooltips"
      .PSZ_TRACKBAR = "Trackbar"
      .PSZ_TRAYNOTIFY = "Tray Notify"
      .PSZ_TREEVIEW = "TreeView"
   End With

   ClassListItems = tmpClassListItems

End Function

'This function needs more attention. Will do that later.
'
'WhatIsThemeFont will return just a string containing the
'font name, not the font object.
'
'Code by Jottum
Public Function WhatIsThemeFont(pszClassListItem As String, lHwnd As Long, lHdc As Long, iPartId As Long, iState As Long) As String

   On Error Resume Next

   Dim tLogFont As FONTSLOG
   Dim hTheme As Long

   If IsThemed(lHwnd) Then

      hTheme = OpenThemeData(lHwnd, StrPtr(ClassListItems.PSZ_BUTTON))

      If hTheme <> 0 Then

         GetThemeFont hTheme, lHdc, iPartId, iState, TMT_FONT, tLogFont

            If tLogFont.flfFaceName <> "" Then

               WhatIsThemeFont = tLogFont.flfFaceName

            Else

               WhatIsThemeFont = "MS Sans Serif"      'Just to be safe...

            End If

         CloseThemeData hTheme

      Else

         WhatIsThemeFont = "MS Sans Serif"

         If InIDE = -1 Then                           'Not good if you get here, so show
                                                      'a message when in the IDE.
            MsgBox "An Error occured retrieving a theme handle from OpenThemeData():   " & vbCrLf & vbCrLf & _
                   " - Function" & vbTab & ": WhatIsThemeFont   " & vbCrLf & _
                   " - Module  " & vbTab & ": XpTransControl.bas   ", vbCritical

         End If

      End If

   Else

      WhatIsThemeFont = "MS Sans Serif"               'Default on any none themed OS, this is
                                                      'the dirty way, I know. :)
   End If

   On Error GoTo 0                                    'Reset error trapping

End Function

'Code by Jottum
Public Function ThemeSysFont() As String

   Dim lHwnd As Long
   Dim lHdc As Long
   Dim lKind As Long
   Dim lState As Long

   lHwnd = GetDesktopWindow
   lHdc = GetDC(lHwnd)
   lKind = 4     '4 = PB_GROUPBOX
   lState = 1    '1 = PBS_NORMAL

   ThemeSysFont = WhatIsThemeFont(ClassListItems.PSZ_BUTTON, lHwnd, lHdc, lKind, lState)
   
   ReleaseDC lHwnd, lHdc

End Function

'Return -1 if we're running in the IDE or 0 if were running compiled.
'Code by vbAccelerator.com

Public Function InIDE() As Long

   Static Value As Long                                  'Static will hold its value.
  
   If Value = 0 Then
   
      Value = 1
      Debug.Assert True Or InIDE()                  'This line won't exist in the
      InIDE = Value - 1                             'compiled app.
      
   End If
  
   Value = 0
   
End Function

'*******************************************************************************************************
'********************************************
'*********************              DrawTabStripCheat
'**
'*
'* Author: Jottum
'* Date  : 07/20/2007 (mm/dd/yyyy)
'* Site  : http://www.uitdeschriften.com/files/VB6/
'*
'* This function draws a tab body behind a (Vb)TabStrip and uses that to make the
'* XpTransControls Transparent. Yes, it's a workaround, but actually the whole
'* transparency thing is. The benifit is speed, although the great transparency
'* function written by GumbyTheCat is using the verry fast API function BitBlt
'* each control still needs to be processed. Not only that, each one has to figure
'* out what control it's contained by, and use that background to simulate transparency.
'*
'* The workaround doesn't need the latter, since what we want as background is drawn
'* on the parent form's device context below the TabStrip. All we have to do now, is
'* set UseParentFormhDC to true for each XpTransControl and skip this way the
'* For Each ... Next loop for EACH XpTransControl you place on the TabStrip.
'*
'* Syntax:
'* 
'* This is the only extra code you'll need to implement
'* a Vb TabStrip control with XpTransControls.
'*
'*    dtsc_Top = TabStrip1.Top
'*    dtsc_Left = TabStrip1.Left
'*    dtsc_Right = TabStrip1.Left + TabStrip1.Width
'*    dtsc_Bottom = TabStrip1.Top + TabStrip1.Height
'*
'*    DrawTabStripCheat Me, dtsc_Top, dtsc_Left, dtsc_Right, dtsc_Bottom
'* ___________
'* End Syntax:
'*
'* The dtsc_* variables are declared public above in General
'*
'**
'*********************
'********************************************
'*******************************************************************************************************

Public Function DrawTabStripCheat(Obj As Object, lTop As Long, lLeft As Long, lRight As Long, lBottom As Long) As Boolean

On Error GoTo ThemeError                              'Catch errors.

   Dim hTheme As Long                                 'Declare local variables
   Dim lR As Long
   Dim tR As RECT
   
   tR.Top = lTop / Screen.TwipsPerPixelY              'Convert and store in RECT
   tR.Left = lLeft / Screen.TwipsPerPixelX
   tR.Right = lRight / Screen.TwipsPerPixelX
   tR.Bottom = lBottom / Screen.TwipsPerPixelY
   
   If IsThemed(Obj.hWnd) Then                         'Check for theme presence
      
      Obj.BackColor = vbButtonFace                    'Should be default with a Tab
                                                      'Control.
      Obj.Cls                                         'Clear Objects surface.
      Obj.AutoRedraw = True                           'Make sure AutoRedraw = True

      hTheme = OpenThemeData(Obj.hWnd, StrPtr(ClassListItems.PSZ_TAB)) 'Open with correct theme item
      
      lR = DrawThemeBackground(hTheme, Obj.hDC, _
                               TAB_BODY, _
                               TIS_NORMAL, _
                               tR, tR)                'Draw Tab body (Gradient
                                                      'background)
                                                      
      CloseThemeData hTheme                           'Release Handle
      DrawTabStripCheat = True                        'Success, return True.
      lR = RefreshXpControls(Obj)                     'Update XpControls
      Exit Function
   
   Else
   
      DrawTabStripCheat = False                       'No Error, but no theming either.
      Exit Function
   
   End If

ThemeError:

   DrawTabStripCheat = False                          'Function failed...


      If MsgBox("An Error occurred in Function DrawTabStripCheat:   " & vbCrLf & vbCrLf & _
                "Return value" & vbTab & ": " & Str$(lR) & vbCrLf & _
                "Error number" & vbTab & ": " & Err.Number & vbCrLf & _
                "Error description" & vbTab & ": " & Err.Description & "   " & vbCrLf & _
                "Error Object" & vbTab & ": " & Obj.Name & vbCrLf & _
                "Error source" & vbTab & ": " & Err.Source & vbCrLf & vbCrLf & _
                "Would you like to try to continue executing this function?   ", _
                 vbExclamation + vbYesNo) = vbYes Then
      
         Resume Next
         
      Else
      
         Resume AllNotSoWell
      
      End If
       

AllNotSoWell:

   Exit Function

End Function

'*******************************************************************************************************
'********************************************
'*********************              FUNCTION IsThemed
'**
'*
'* Author: Jottum
'* Date  : 07/20/2007 (mm/dd/yyyy)
'* Site  : http://www.uitdeschriften.com/files/VB6/
'*
'* The function IsThemed checks if there's any theming going on, if so it tries to get a
'* handle from the function OpenThemeData. If this succeeds the hTheme variable contains
'* that handle, otherwise it's 0. (If it's 0 you can't use the theme functions.)
'*
'* The hWnd parameter is optional, the default is the Desktop's. Me.hWnd is just an example,
'* any valid hWnd - or none at all, it'll fetch the desktop's - will do.
'*
'* The IT_SHOWERRMSG (bShowErrorMessage) parameter is optional, the default is False which means
'* it doesn't show the errors (if any) it traps. It could be useful - for example when debuging
'* unexpected behavior in your application, or while still developing - to set it to true.
'*
'* Syntax:
'* 
'*    Dim bShowErrorMessage As Boolean                'If declared Public in a module, you can
'*                                                    'set this flag application wide.
'*    Dim bReturnValue As Boolean
'*
'*    bShowErrorMessage = True
'*
'*    bReturnValue = IsThemed([ANY_VALID_HWND], [bShowErrorMessage])
'*
'*                   Or
'*
'*    bReturnValue = IsThemed([ANY_VALID_HWND], [IT_SHOWERRMSG])
'*
'*                   Or                               'No hWnd, static show Error Messages.
'*
'*    bReturnValue = IsThemed(, [IT_SHOWERRMSG])
'*
'*                   Or
'*
'*    If IsThemed() then
'*
'*       ' Your theme code here...
'*
'*    Else
'*
'*       ' Your legacy code here...
'*
'*    Endif
'* ___________
'* End Syntax:
'*
'**
'*********************
'********************************************
'*******************************************************************************************************

Public Function IsThemed(Optional hWnd As Long = 0, Optional ShowErrMsg As Boolean = False) As Boolean

On Error GoTo ThemeError                              'Catch errors                                                  'Catch errors...
                                                      
   Dim hTheme As Long                                 'Declare variable for Theme Handle
   
   If IsThemeActive() Then                            'Ah, themes! Now try to get a handle.
   
      If (hWnd = 0) Then                              'But first make sure we've got a valid
                                                      'hWnd passed, and if not get the
         hWnd = GetDesktopWindow                      'Desktop's
      
      End If
                                                      'Any pszClasslist item will do, I
      hTheme = OpenThemeData(hWnd, StrPtr(ClassListItems.PSZ_STATUS))
                                                      'just picked "Status" at random.
      If (hTheme <> 0) Then                           'We've got a handle
   
         CloseThemeData hTheme                        'Release handle.
         IsThemed = True                              'Return Success.
         
         Exit Function                                'We don't want to bump into
                                                      'ThemeError. ;)
      Else
         
         IsThemed = False                             'Can't get a handle, so nothing is open.
         
         Exit Function                                'Let's split!
         
      End If
   
   Else
   
      IsThemed = False                                'No theming!
      
      Exit Function                                   'Let's split here too!
   
   End If

ThemeError:

   IsThemed = False                                   'Don't forget to set flag to false.

   If ShowErrMsg Then                                 '... display MessageBox with Error
   
      MsgBox "An Error occurred in Function IsThemed: " & vbCrLf & vbCrLf & _
             "Error number" & vbTab & ": " & Err.Number & vbCrLf & _
             "Error description" & vbTab & ": " & Err.Description & "   " & vbCrLf & _
             "Error source" & vbTab & ": " & Err.Source & vbCrLf & vbCrLf & _
             "Code execution has stopped for this call.   ", vbExclamation

   End If

   Resume AllNotSoWell

AllNotSoWell:

   Exit Function

End Function

'Code by Jottum
Public Function RefreshXpControls(Obj As Object) As Boolean

   Dim cControl As Control
   RefreshXpControls = False

   On Error GoTo RefreshErr

   For Each cControl In Obj.Controls

      If TypeOf cControl Is XPdivider Or _
         TypeOf cControl Is XpGroupBox Or _
         TypeOf cControl Is XPOptionCheck Then
   
         cControl.Refresh
   
      End If
      
   Next
   
   RefreshXpControls = True
   Exit Function

RefreshErr:

   If MsgBox("An Error occurred in Function RefreshXpControls: " & vbCrLf & vbCrLf & _
             "Error number" & vbTab & ": " & Err.Number & vbCrLf & _
             "Error description" & vbTab & ": " & Err.Description & "   " & vbCrLf & _
             "Error source" & vbTab & ": " & Err.Source & vbCrLf & _
             "Error Object" & vbTab & ": " & Obj.Name & vbCrLf & vbCrLf & _
             "Would you like to try to continue executing this function?   ", _
              vbYesNo + vbExclamation) = vbYes Then
      
      Resume Next
      
   Else
   
      Resume AllNotSoWell

   End If

AllNotSoWell:

   Exit Function

End Function

'I have no idea, who to give credit for the original code.
Public Property Get CollectControlsContainedBy(Obj As Object) As Collection
   
   'Returns a collection of controls that are contained by Obj, you can use it
   'to apply global settings for each control, like font or adjusting control
   'position if legacy drawing is used.
   
   Dim TempControl As Control
   Dim kColl As Collection
   Dim lOldWidth As Long
   
   Set kColl = New Collection
   
   For Each TempControl In Obj.Controls               'Loop through all controls on Obj
   
       On Error Resume Next                           'Catch errors, but let loop finish.
   
       kColl.Add TempControl                          'Add them to collection
       
       If Not IsThemed(Obj.hWnd) Then                 'Check for theming and adjust any
                                                      'control that's on a TextboxXp frame.
          If InStrB(TempControl.Tag, "OnXpBox") <> 0 Then
         
             TempControl.Top = TempControl.Top - Obj.ScaleY(2, vbPixels, vbTwips)
             TempControl.Left = TempControl.Left - Obj.ScaleX(2, vbPixels, vbTwips)
            
          End If

       End If
       
       If TypeOf TempControl Is TextBox Then          'Only change a textbox font on "request"
       
         If InStrB(TempControl.Tag, "ThemeMyFont") <> 0 Then
          
            TempControl.Font.Name = ThemeSysFont
            TempControl.Font = ThemeSysFont
                        
         End If
          
       Else                                           'Change all the others.
       
         TempControl.Font.Name = ThemeSysFont
         TempControl.Font = ThemeSysFont
         
         If TypeOf TempControl Is Label Then
            TempControl.Refresh                       'Incase autosize = true...
         End If
            
       End If
       
       DoEvents                                       'Give Windows some breathing space while
                                                      'looping through all controls.
   Next TempControl
   
   Set CollectControlsContainedBy = kColl             'Return the collection.
   
   On Error GoTo 0
   
End Property

Public Property Get DTTB_HIDEPANE() As Boolean

   DTTB_HIDEPANE = True

End Property

Public Property Get DTTB_SHOWPANE() As Boolean

   DTTB_SHOWPANE = False

End Property

Public Property Get DTTB_SHOWERRMSG() As Boolean

  DTTB_SHOWERRMSG = True

End Property

Public Property Get DTTB_HIDERRMSG() As Boolean

  DTTB_HIDERRMSG = False

End Property

Public Property Get DTTB_HIDEBODY() As Boolean

   DTTB_HIDEBODY = True

End Property

Public Property Get IT_SHOWERRMSG() As Boolean

  IT_SHOWERRMSG = True

End Property

Public Property Get DTSC() As DTSCRECT

End Property

Public Property Let DTSC(ByRef Setting As DTSCRECT)

   LSet DTSC = Setting

End Property

'Code by Jottum
Public Function StartURL(URL As String) As Long

   Dim lHwnd As Long
   lHwnd = GetDesktopWindow()
   
   StartURL = ShellExecute(lHwnd, "Open", URL, vbNullString, vbNullString, SW_SHOWNORMAL)

End Function

'Code by Jottum
Public Function StartExe(ExeName As String, strParam As String, ExecutePath As String) As Long

   Dim lHwnd As Long
   lHwnd = GetDesktopWindow()
   
   StartExe = ShellExecute(lHwnd, "Open", ExeName, strParam, ExecutePath, SW_SHOWNORMAL)

End Function

'Code by Jottum
Public Function IsFile(Filename As String, Optional Folder As Boolean = False) As Boolean

   IsFile = False                   'Set default to false
   
   If Filename <> vbNullString Then ' Empty call will return False without
                                    ' bothering to check. <g>
      If Folder Then
         
         If Dir(Filename, vbDirectory + vbVolume + vbArchive + vbNormal + vbHidden + vbReadOnly + vbSystem) <> vbNullString Then
            
            IsFile = True
         
         End If
      
      Else
         
         If Dir(Filename, vbVolume + vbArchive + vbNormal + vbHidden + vbReadOnly + vbSystem) <> vbNullString Then
            
            IsFile = True
         
         End If
      
      End If
   
   End If

End Function

'Code by Jottum
Public Function DisableCaret(cControl As Object) As Boolean

   Dim retVal As Integer
   
   DisableCaret = False 'Default to False, only success can change that from here on.
   
   On Error Resume Next 'Trap errors
   
   retVal = HideCaret(cControl.hWnd)
   
   If retVal <> 0 Then
      DisableCaret = True
   End If

   On Error GoTo 0

End Function

'Code by Jottum
Public Function EnableCaret(cControl As Object) As Boolean

   Dim retVal As Integer
   
   EnableCaret = False 'Default to False, only success can change that from here on.
  
   On Error Resume Next 'Trap errors
   
   retVal = ShowCaret(cControl.hWnd)
   
   If retVal <> 0 Then
      EnableCaret = True
   End If

   On Error GoTo 0

End Function

'Code by Jottum
Public Function TextBoxLines(TBox As Object) As Long

   On Error Resume Next 'Trap errors

   'Remove comment below if you want to test the result, -1 is always trouble.
   'TextBoxLines = -1

   TextBoxLines = SendMessageLong(TBox.hWnd, EM_GETLINECOUNT, 0, 0)

End Function
